/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package examples;

import java.util.Iterator;
import org.odmg.DBag;
import org.odmg.Database;
import org.odmg.Implementation;
import org.odmg.ODMGException;
import org.odmg.OQLQuery;
import org.odmg.Transaction;
import rasj.RasImplementation;

public class QueryExample
{
    public final String query = "select add_cells(<[0:2] 1.042323, 1.12, 1.8>) from mr2 as c";

    private String server;
    private String base;
    Implementation myApp = null;
    Database myDb = null;
    Transaction myTa = null;

    public QueryExample(String s, String b)
    {
        this.server = s;
        this.base = b;

        myApp = new RasImplementation(server);
        myDb = myApp.newDatabase();
    }

    public void log(String msg)
    {
        System.err.flush();
        System.out.println("log> " + msg);
        System.out.flush();
    }

    private void init() throws ODMGException
    {
        if (myApp == null)
        {
            myApp = new RasImplementation(server);
        }
        if (myDb == null)
        {
            myDb = myApp.newDatabase();
        }
        log("Opening database...");
        myDb.open(base, Database.OPEN_READ_ONLY);
        log("Beginning new transaction ...");
        myTa = myApp.newTransaction();
        myTa.begin();
    }

    private void finish() throws ODMGException
    {
        log("Commiting transaction ...");
        myTa.commit();
        log("Closing database...");
        myDb.close();
        log("Finished !");
    }

    private void abort() throws ODMGException
    {
        log("Aborting transaction...");
        myTa.abort();
        log("Closing database...");
        myDb.close();
        log("Finished !");
    }

    public void sendQuery() throws ODMGException
    {
        init();

        log("Executing query: " + query);
        OQLQuery myQu = myApp.newOQLQuery();
        myQu.create(query);

        DBag resultSet = (DBag) myQu.execute();
        if (resultSet != null)
        {
            Iterator iter = resultSet.iterator();
            while (iter.hasNext())
            {
                Double res = (Double) iter.next();
                System.out.println("*** Result is: " + res);
            }
        }

        finish();
    }

    public static void main(String[] args) throws ODMGException
    {
        QueryExample ex = new QueryExample(
                "http://localhost:7001", "RASBASE");
        ex.sendQuery();
    }
}
